#!/usr/bin/env python3
"""
Simple example of the stomp module usage. Connect to a STOMP
server and sent messages at random intervals. Register a 
Dispatcher and a Subscriber to print messages indefinatly.
"""
import os
import time
import sys
import random


if __name__ == '__main__':
    from stomp.frame import Send
    from stomp.frame import Subscribe
    from stomp import const
    import stomp.transport

    dsn = "tcp://debug:debug@srv0003.tnginformationsystems.com/apollo"
    transport = stomp.transport_factory(dsn, heartbeats=(0, 500))

    subscribe = Subscribe('/topic/test', ack=const.ACK_AUTO)
    transport.send_frame(subscribe)
    
    publisher = stomp.Publisher(transport)
    dispatcher = stomp.FrameDispatcher()
    transport.set_dispatcher(dispatcher)

    while True:
        time.sleep(float(random.randint(1, 3)))
        publisher.publish('/topic/test', "Random test message sent at {0}".format(time.time()),
            receipt=True)
        


