
ALLOWED_CHANNEL_PREFIXES = ['queue', 'topic']

EOL = chr(10)
EOF = chr(0)

# Frame type definitions
CONNECT     = 'CONNECT'
CONNECTED   = 'CONNECTED'
DISCONNECT  = 'DISCONNECT'
SUBSCRIBE   = 'SUBSCRIBE'
UNSUBSCRIBE = 'UNSUBSCRIBE'
ACK         = 'ACK'
NACK        = 'NACK'
BEGIN       = 'BEGIN'
COMMIT      = 'COMMIT'
ABORT       = 'ABORT'
DISCONNECT  = 'DISCONNECT'
MESSAGE     = 'MESSAGE'
RECEIPT     = 'RECEIPT'
ERROR       = 'ERROR'
SEND        = 'SEND'

FRAME_TYPES = frozenset([
    CONNECT, DISCONNECT, SUBSCRIBE, UNSUBSCRIBE, ACK, NACK, BEGIN,
    COMMIT, ABORT, MESSAGE, RECEIPT, ERROR, SEND
])

ACK_CLIENT      = 'client'
ACK_AUTO        = 'auto'
ACK_INDIVIDUAL  = 'client-individual'
VALID_ACK_MODES = frozenset([
    ACK_CLIENT, ACK_AUTO, ACK_INDIVIDUAL])


#: The minimum heartbeat interval.
MINIMUM_HEARTBEAT_INTERVAL = 0.1
