from stomp.const import EOL
import stomp.headers


class FrameHeader(object):
    """Represents a header in a STOMP frame."""

    name = property(lambda self: self._name)
    value= property(lambda self: self._value)

    @classmethod
    def parse(cls, raw_header):
        """Parses a raw header from a message.

        Args:
            raw_header (str): a raw header in the format <name>:<value>
        """
        return cls(*raw_header.split(':'))

    def __init__(self, name, value):
        """Initialize a new :class:`FrameHeader` instance.

        Args:
            name (str): the name of the header.
            value (str): the value of the header.
        """
        self._name = name
        self._value = value

    def __str__(self):
        # TODO: Ugly but works.
        if self._name == stomp.headers.DESTINATION\
        and isinstance(self._value, (list, tuple)):
            self._value = ','.join(self._value)
        return "{0}:{1}".format(self._name, self._value) + EOL
