import unittest
import socket

from stomp.test.const import MOCK_ADDR
from stomp.test.const import MOCK_DSN
import stomp


class StompSocketTestCase(unittest.TestCase):
    """Binds a local socket that acts as a STOMP server."""
    
    def setUp(self):
        self.socket = socket.socket(socket.AF_INET,
            socket.SOCK_STREAM)
        self.socket.setsockopt(socket.SOL_SOCKET,
            socket.SO_REUSEADDR, 1)
        self.socket.bind(MOCK_ADDR)
        self.socket.listen(1)
        self.transport = stomp.transport_factory(MOCK_DSN)
        self.connection, self.address = self.socket.accept()

    def tearDown(self):
        self.transport.destroy()
        self.connection.close()
        self.socket.close()
