import unittest
import socket
import time

import stomp.test
import stomp


class ErrorFrameHandlingTestCase(stomp.test.StompSocketTestCase):

    def get_error_frame(self, **headers):
        return bytes(stomp.datastructures.Frame(
            stomp.const.ERROR, headers=headers))

    def test_error_frame_closes_transport(self):
        frame = self.get_error_frame()
        self.connection.send(frame)
        time.sleep(1)
    
        self.assertTrue(self.transport._exception is not None)
        self.assertEqual(type(self.transport._exception), 
            stomp.exceptions.StompException)
        self.assertTrue(self.transport.closed)

    def test_sending_raises_exception_after_error_frame(self):
        frame = self.get_error_frame()
        self.connection.send(frame)
        time.sleep(1)
        
        func = self.transport.send_frame
        args = ['/queue/testing']
        self.assertRaises(stomp.exceptions.StompException,
            func, *args)
